/*
 * Copyright (c) 2012, IDM
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted
 * provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright notice, this list of
 *       conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright notice, this list
 *       of conditions and the following disclaimer in the documentation and/or other materials
 *       provided with the distribution.
 *     * Neither the name of the IDM nor the names of its contributors may be used to endorse or
 *       promote products derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

var fs = require('fs');
var request = require('sync-request');

// As the skpublishapi is not a node package.
eval(fs.readFileSync('./skpublishapi.js')+'');

var serverName = "<server_name>";
var accessKey = "<access_key>";

var api = new SkPublishAPI ('http://'+serverName+'/api/v1', accessKey);


var request = require('sync-request');

api.setRequestHandler({
  executeRequest : function(response) {
    var content = response.getBody();
    content = "" + content; //Force content as string instead of buffer
    return content;
  },

  prepareGetRequest : function(uri, accessKey) {
    var res = request('GET', uri, {
      'headers': {
        'accessKey': accessKey,
        'Content-Type': 'application/json'
      }
    });
    return res;
  }
});

console.log("*** Dictionaries\n");
dictionaries = api.getDictionaries();

var dict = eval(dictionaries)[0];
console.log(dict);
for(var elt in dict){
  infoVal = eval("dict."+elt);
  if (typeof infoVal == 'function') { continue; }
  console.log (elt + " : " + infoVal + " ; ");
}
console.log ("\n");
dictCode = dict.dictionaryCode;

console.log ("*** Search\n");
console.log ("*** Result list\n");
results = api.search(dictCode, "ca", 1, 1);
console.log (results+"\n");
console.log ("*** Spell checking\n");
spellResults = api.didYouMean(dictCode, "dorg", 3);
console.log (spellResults+"\n");
console.log ("*** Best matching\n");
bestMatch = api.searchFirst(dictCode, "ca", "html");
console.log (bestMatch+"\n");

console.log ("*** Nearby Entries\n");
nearbyEntries = api.getNearbyEntries(dictCode, eval('['+bestMatch+']')[0].entryId, 3);
console.log (nearbyEntries+"\n");
